import java.util.Timer;

public class Schedule {
    int     id;
    long    expiration;
    int     fire;
    int     period;
    boolean isRelative;
    String  name;
    Timer   timer;

    Schedule(String name, long expiration, int fire, int period, boolean isRelative) {
        this.expiration = expiration;
        this.fire = fire;
        this.period = period;
        this.isRelative = isRelative;
        this.name = name;
    }
    
    Schedule(int id, byte[] record) { 
        this.id = id;
        expiration = Converter.unpackLong(record, 0);
        fire = Converter.unpackInt(record, 8);
        period = Converter.unpackInt(record, 12);
        isRelative = record[16] != 0;
        name = Converter.unpackString(record, 17, record.length - 17);
    }

    byte[] pack() { 
        byte[] record = new byte[name.length()*2 + 17];
        Converter.packLong(record, 0, expiration);
        Converter.packInt(record, 8, fire);
        Converter.packInt(record, 12, period);
        record[16] = (byte)(isRelative ? 1 : 0);
        Converter.packString(record, 17, name);
        return record;
    }
}