import javax.microedition.lcdui.*;
import java.util.*;

public class TimerList extends List implements CommandListener 
{
    Scheduler scheduler;
    Displayable parent;

    TimerList(Scheduler scheduler, Displayable parent) {
        super(Locale.TIMER_LIST, IMPLICIT);
        this.scheduler = scheduler;
        this.parent = parent;
        Vector timers = scheduler.timers;
        int n = timers.size();
        for (int i = 0; i < n; i++) { 
            Schedule s = (Schedule)timers.elementAt(i);
            append(s.name, null);
        }
        addCommand(Scheduler.NEW_CMD);
        if (n != 0) { 
            addCommand(Scheduler.DELETE_CMD);
        }
        addCommand(Scheduler.BACK_CMD);
        setCommandListener(this);
        scheduler.display.setCurrent(this);
    }
       
    public void commandAction(Command c, Displayable d)  {
        if (c == Scheduler.NEW_CMD) {             
            new NewTimerForm(scheduler, this, null);
        } else if (c == Scheduler.BACK_CMD) {             
            scheduler.display.setCurrent(parent);
        } else if (c == Scheduler.DELETE_CMD) {             
            int i = getSelectedIndex();
            if (i >= 0) { 
                scheduler.deleteTimer(i);
                delete(i);
            }
        } else {
            int i = getSelectedIndex();
            if (i >= 0) { 
                new NewTimerForm(scheduler, this, (Schedule)scheduler.timers.elementAt(i));
            } else { 
                new NewTimerForm(scheduler, this, null);
            }
        }
    }
} 
            
